
volatile u32 tim0,tim1,tim2;
volatile u32 tim_led;

extern "C"
{
 void SysTick_Handler()
 {
  if(tim0)tim0--;
  if(tim1)tim1--;
  if(tim2)tim2--;

  if(tim_led)tim_led--;
  if(beep_tim)
  {
   beep_tim--;
   TIM14->CR1 = TIM_CR1_CEN;
  }
  else TIM14->CR1 = 0;



  static bool trg=0;
  trg^=1;
  if(trg) kb_state = btn_scan();
 }
//-----------------------------------

 void DMA1_Channel4_5_IRQHandler()
 {
  // 
  DMA1_Channel5->CCR = 0;
  __DSB();

  DMA1_Channel5->CNDTR = w_size<<1;
  DMA1_Channel5->CMAR  = (uint32_t)hf_wave[bank_dma];

  // ,  
  DMA1_Channel5->CCR   = DMA_CCR_MINC    | //memory incremental mode
                         DMA_CCR_CIRC    | //circular mode
                         DMA_CCR_MSIZE_0 | //16 bit
                         DMA_CCR_PSIZE_0 | //16 bit
                         DMA_CCR_PL      | //vh priority
                         DMA_CCR_DIR     | //read from memory
                         DMA_CCR_EN;
 }

//-----------------------------------

 void TIM2_IRQHandler()
 {
  TIM2->SR   = 0;


  __DSB();
 }

//-----------------------------------

 void TIM16_IRQHandler()
 {
  TIM16->SR = 0;
  __DSB();
 }

//-----------------------------------

 void HardFault_Handler()
 {

  while(1)
  {
   __no_operation();

//   static volatile int k=0;
//   static bool trg;
//
//   if(k)k--;
//   else
//   {
//    trg ^=1;
//    k = 0xfffff;
//
//    if(trg)led(true);
//    else   led(false);
//   }
  }
 }

 void NMI_Handler()
 {
  //  ram parity checking fail,   
  while(1)__no_operation();
 }

 void Default_Handler()
 {

  while(1)__no_operation();
 }
}



//   Reset_Handler                  ; Reset Handler
//
//   NMI_Handler                    ; NMI Handler
//   HardFault_Handler              ; Hard Fault Handler
//   PendSV_Handler                 ; PendSV Handler
//   SysTick_Handler                ; SysTick Handler
//
//  ; External Interrupts
//   WWDG_IRQHandler                ; Window Watchdog
//   PVD_IRQHandler                 ; PVD through EXTI Line detect
//   RTC_IRQHandler                 ; RTC through EXTI Line
//   FLASH_IRQHandler               ; FLASH
//   RCC_IRQHandler                 ; RCC
//   EXTI0_1_IRQHandler             ; EXTI Line 0 and 1
//   EXTI2_3_IRQHandler             ; EXTI Line 2 and 3
//   EXTI4_MDEV_IRQHandler            ; EXTI Line 4 to MDEV
//   TS_IRQHandler                  ; TS
//   DMA1_Channel1_IRQHandler       ; DMA1 Channel 1
//   DMA1_Channel2_3_IRQHandler     ; DMA1 Channel 2 and Channel 3
//   DMA1_Channel4_5_IRQHandler     ; DMA1 Channel 4 and Channel 5
//   ADC1_COMP_IRQHandler           ; ADC1, COMP1 and COMP2
//   TIM1_BRK_UP_TRG_COM_IRQHandler ; TIM1 Break, Update, Trigger and Commutation
//   TIM1_CC_IRQHandler             ; TIM1 Capture Compare
//   TIM2_IRQHandler                ; TIM2
//   TIM3_IRQHandler                ; TIM3
//   TIM6_DAC_IRQHandler            ; TIM6 and DAC
//   0                              ; Reserved
//   TIM14_IRQHandler               ; TIM14
//   TIMMDEV_IRQHandler               ; TIMMDEV
//   TIM16_IRQHandler               ; TIM16
//   TIM17_IRQHandler               ; TIM17
//   I2C1_IRQHandler                ; I2C1
//   I2C2_IRQHandler                ; I2C2
//   SPI1_IRQHandler                ; SPI1
//   SPI2_IRQHandler                ; SPI2
//   USART1_IRQHandler              ; USART1
//   USART2_IRQHandler              ; USART2
//   0                              ; Reserved
//   CEC_IRQHandler                 ; CEC
//   0                              ; Reserved

